summaryrefslogtreecommitdiff
path: root/tests/misc
diff options
context:
space:
mode:
authorEric Blake <ebb9@byu.net>2008-06-11 09:14:26 -0600
committerJim Meyering <meyering@redhat.com>2008-06-13 23:06:03 +0200
commit46a811b9e7c0e9fefb75864d198f9a4f3fd0e6cf (patch)
tree8f3007517c9197342afa85dde87e9638d7d84ad7 /tests/misc
parentbbbc35c9ed194b0d458f2a2827dfbceb9056ef7d (diff)
downloadcoreutils-46a811b9e7c0e9fefb75864d198f9a4f3fd0e6cf.tar.xz
od: align multiple -t specs
* src/od.c (struct tspec): Add pad_width field, and adjust print_function prototype. (decode_one_format): Rewrite all fmt_string values to account for pad width. (FMT_BYTES_ALLOCATED): Adjust to new format style. (main): Compute pad width per spec. (write_block): Account for pad width. (dump): Don't print padding-only fields. (PRINT_TYPE, print_named_ascii, print_ascii): All print functions adjusted to use variable pad width. * tests/Makefile.am (TESTS): Add test. * tests/misc/od-multiple-t: New file. * THANKS: Update. * NEWS: Mention the improvement. Reported by Gary Johnson.
Diffstat (limited to 'tests/misc')
-rwxr-xr-xtests/misc/od-multiple-t47
1 files changed, 47 insertions, 0 deletions
diff --git a/tests/misc/od-multiple-t b/tests/misc/od-multiple-t
new file mode 100755
index 000000000..63fb7e424
--- /dev/null
+++ b/tests/misc/od-multiple-t
@@ -0,0 +1,47 @@
+#!/bin/sh
+# verify that multiple -t specifiers to od align well
+# This would fail before coreutils-6.13.
+
+# Copyright (C) 2008 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ od --version
+fi
+
+. $srcdir/test-lib.sh
+
+# Choose 48 bytes for the input, as that is lcm for 1, 2, 4, 8, 12, 16;
+# we don't anticipate any other native object size on modern hardware.
+seq 19 > in || framework_failure
+test `wc -c < in` -eq 48 || framework_failure
+
+fail=0
+
+list='a c dC dS dI dL oC oS oI oL uC uS uI uL xC xS xI xL fF fD fL'
+for format1 in $list; do
+ for format2 in $list; do
+ od -An -t${format1}z -t${format2}z in > out-raw || fail=1
+ linewidth=`head -n1 out-raw | wc -c`
+ linecount=`wc -l < out-raw`
+ echo $format1 $format2 `wc -c < out-raw` >> out
+ echo $format1 $format2 `expr $linewidth '*' $linecount` >> exp
+ done
+done
+
+compare out exp || fail=1
+
+(exit $fail); exit $fail